########################################################################
# Dependencies:
# install the perl module "WWW::Mechanize"
#
# Settings:
# /set xxbin_standard_lang LANG
# /set xxbin_output_public ON/OFF (post public or not)
# /set xxbin_output_message HERE THE URL (only needed if public post)
# /set xxbin_private_data ON/OFF (privates your data on gbpaste)
# /set xxbin_private_nick ON/OFF (set Name with your nick or anonymus)
# /set xxbin_display_paste ON/OFF (if on all you paste will be displayed
#                                   [only to see for you])
#
# Usage:
# /read
# Write/Paste all u want to get on bin.xx4h.de
# /paste [-l [LANG]]
# - only -l argument will show u a list of available code-langs
# - with -l LANG will post it to gbpaste in choosen language
# - without anything the xxbin_standard_lang is used
#
# if there are bugs etc. pls mail to me =) thx
#
#######################################################################
# Changelog:
# - added options for public/private
# - added some exception handling
#
######################################################################

use strict;
use Encode;
use IO::Socket::SSL qw();
use WWW::Mechanize qw();

use vars qw($VERSION %IRSSI $PWD);

use Irssi qw(); #qw(command_bind);
$VERSION = '0.14';
%IRSSI = (
    authors     =>  'xx4h',
    contact     =>  'melters@gmail.com',
    name        =>  'xxbin',
    description =>  'This script auto-paste'.
                    'your lines to bin.xx4h.de'.
                    'and posts the link to it'.
                    'in the channel',
    changed     =>  'Mon, Feb 21 02:39 2011',
    license     =>  'Public Domain',
);

my $url = "https://bin.xx4h.de/index.php";
my @_paste = undef;
my @langs;
my $agent = WWW::Mechanize->new(ssl_opts => {
    SSL_verify_mode => IO::Socket::SSL::SSL_VERIFY_NONE,
    verify_hostname => 0
});

my $nickname = Irssi::settings_get_str("nick");

eval {
    open FILE, "<$PWD.irssi/scripts/langs";
    @langs = <FILE>;
    Irssi::print("PasteScript:". ($#langs + 1) ." language codes loaded", MSGLEVEL_CRAP);
    close FILE;
};
if ($@) {
    Irssi::print("languages file not found", MSGLEVEL_CRAP);
};


sub begin_paste {
    my ($arg, $server, $witem) = @_;
    @_paste = ();
    Irssi::signal_add_first("send text", "paste");

    $agent->agent_alias("Windows Mozilla");
    eval {
    $agent->get($url);
    }; die "no success :(" ,$agent->response->status_line unless $agent->success;
    if ($@) {
    Irssi::print("something went wrong, pls try again", MSGLEVEL_CRAP);
    };
}

sub paste {
    my ($data) = @_;
    push @_paste, $data;
    if (Irssi::settings_get_bool("xxbin_display_paste") == 1) {
        Irssi::print("$data", MSGLEVEL_CRAP);
    }
    Irssi::signal_stop();
}


sub stop_paste {
    my ($arg, $server, $witem, $args) = @_;
    my $output_message = Irssi::settings_get_str("xxbin_output_message");
    my $language;
    my @arguments = split(' ', $args);


    my $count = @arguments;
    for (my $i=0;$i<$count;$i++) {
    if (@arguments[$i] =~ /^-l/) {
        my $argu = @arguments[$i + 1];
        if ($argu eq undef) {
                        Irssi::print("@langs", MSGLEVEL_CRAP);
                        Irssi::print("Use one of the above langs");
                        return;
                }
        for (my $t=0;$t<=$#langs;$t++) {

            if (@langs[$t] eq "$argu\n") {
                $language = $argu;
                Irssi::print("posting with $language format");
            }
        }
        if ($language eq undef) {
                        Irssi::print("$argu is not in the library! Type \"/paste -l\" to get the list");
                        return;
                }

        }
    }

    Irssi::signal_remove("send text", "paste");
    Irssi::print('Sending ' . ($#_paste + 1) . ' lines to bin.xx4h.de...');

    my $data;
    $data = join("\n", @_paste);
    $data = decode("utf-8", $data);
    if ($data eq undef) {
    Irssi::print("there is nothing to paste!", MSGLEVEL_CRAP);
    return 0;
    }

    $agent->field("message", $data);

    # nick or anonymus
    if (Irssi::settings_get_bool("xxbin_burn_after") == 0) {
    $agent->tick("burnafterreading", 'off');
    } else {
    $agent->tick("burnafterreading", 'on');
    }

    # private or not
    if (Irssi::settings_get_bool("xxbin_hilight") == 1) {
    $agent->tick("syntaxcoloring", 'on');
    }

    # public discussion
    if (Irssi::settings_get_bool("xxbin_public_discuss") == 1) {
        $agent->tick("opendiscussion", 'on');
    }

    #if ($language eq undef) {
    #$agent->field("lang", "text");
    #} else {
    #$agent->field("lang", $language);
    #}
    #$agent->click();



    my $pasteurl = $agent->uri();
    if (Irssi::settings_get_bool("xxbin_output_public") == 0) {
    Irssi::print("xxbin URL: $pasteurl", MSGLEVEL_CRAP);
    } else {
    $witem->command("/SAY $output_message $pasteurl");
    }

}
Irssi::settings_add_str("misc", "xxbin_output_message", "here teh url:");
Irssi::settings_add_bool("misc", "xxbin_output_public", 0);
Irssi::settings_add_bool("misc", "xxbin_hilight", 0);
Irssi::settings_add_bool("misc", "xxbin_burn_after", 0);
Irssi::settings_add_bool("misc", "xxbin_display_paste", 0);
Irssi::settings_add_bool("misc", "xxbin_public_discuss", 0);

Irssi::command_bind read => \&begin_paste;
Irssi::command_bind paste => \&stop_paste;

